using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    public class Connector : ProcessObject, IHideShowChildren, ISaveMyself
    {
        delegate void SetInternalProps();

        SetInternalProps SetOr; //Switches the orientaion of the Connector

        //SetInternalProps SetCtrlAlign; //Refers to methods which place the controls inside the Connector

        SetInternalProps SetlblResizeAction; //Refers to either VirtSetControlsOtherThanlbl, HorisSetControlsOtherThanlbl

        SetInternalProps SetConHorisWidth;

        SetInternalProps UpdateDimention;

        SetInternalProps CheckVirtHorisInBounds;

        LineArrow LA;

        DeleteNodeCon DN;

        NodeMove NM = new NodeMove();

        RotateNode RN = new RotateNode();

        NodeProperties NP = new NodeProperties();

        Label lblNote = new Label();

        //NodeResize NMTopLeft = new NodeResize();

        ConnectorResize NMBottomRight = new ConnectorResize();

        bool AreChildButtonsVisible;

        static int HHieght = 60;  // The width of the Connector if it is virtically oriented. 
                                  // The height of the Connector if it is horisontally oriented.

        int ConWidth = 300;

        int ConMinSize;

        //int DrawingWidth = 300;

        //bool Orientation; //True: Horisontal, False: Vertical

        public Connector() {

            Initalise();

        }

        public void LoadConnector(string NewText, string NewHorisontial, string NewConWidth, string NewArrowState, string NewLabelVisibleState, string LocationX, string LocationY)
        {
            //Initalise();

            Text = NewText;

            bool IsHorisontial = bool.Parse(NewHorisontial);

            ConWidth = int.Parse(NewConWidth);

            if (!IsHorisontial)
            {

                Height = ConWidth;

                SwitchOrientation();

                //VirticalCtrlLocs();

                UpdateHeight();

            } else
            {

                Width = ConWidth;

                //HorisontalCtrlLocs();

                UpdateWidth();
                
            }          

            switch (NewArrowState)
            {

                case "BottomOrRight":

                    ArrowState = ArrowStates.BottomOrRight;

                    break;

                case "TopOrLeft":

                    ArrowState = ArrowStates.TopOrLeft;

                    break;

            }

            ////if (!bool.Parse(NewLabelVisibleState))
            //    lblNote.Visible = false;

            lblNote.Visible = bool.Parse(NewLabelVisibleState);

            Location = new Point(int.Parse(LocationX), int.Parse(LocationY));
        }

        void Initalise()
        {

            lblNote.AutoSize = true;

            lblNote.Text = "New Link";

            DN = new DeleteNodeCon(NP);

            Controls.Add(DN);

            Controls.Add(NM);

            Controls.Add(RN);

            Controls.Add(NP);

            Controls.Add(lblNote);

            //Controls.Add(NMTopLeft);

            Controls.Add(NMBottomRight);

            //BackColor = SystemColors.Window;

            SetOr = HorisontalOr;

            lblNote.SizeChanged += new EventHandler(lblNote_SizeChanged);

            //lblNote.BackColor = Color.Blue;

            //BackColor = Color.Blue;

            lblNote.BackColor = Color.Transparent;

            SetConHorisWidth = WithLabel;

            //UpdateWidth();

            SetOr();  //Sets horisontal

            //SizeChanged += new EventHandler(Connector_SizeChanged);

            //Width = DrawingWidth;

            HorisontalCtrlLocs();

            //LA.Horisontal = true;

            LA = new LineArrow(this);

            //Paint += new PaintEventHandler(Connector_Paint);

            //AS = ArrowStates.None;
            //Set Inital/Virtical Locations

            CheckVirtHorisInBounds = CheckInboundsX;
            //Refresh();

            lblNote.SizeChanged += new EventHandler(lblNote_SizeChanged);

            Name = "Connector";


        }

        public XElement ProfileMe()
        {

            //List<XAttribute> MyAttributes = ProfilePONode();

            XElement MeInXmlForm = new XElement(Name);

            //foreach (XAttribute Attribute in MeInXmlForm.Attributes())
            //    MeInXmlForm.Add(Attribute);

            MeInXmlForm.Add(new XAttribute("Text", Text));
            MeInXmlForm.Add(new XAttribute("Horisontial", HOrientation().ToString()));
            MeInXmlForm.Add(new XAttribute("ConWidth", ConWidth));
            MeInXmlForm.Add(new XAttribute("ArrowState", ArrowState.ToString()));
            MeInXmlForm.Add(new XAttribute("LabelVisibleState", LabelVisibleState));
            MeInXmlForm.Add(new XAttribute("Location.X", Location.X));
            MeInXmlForm.Add(new XAttribute("Location.Y", Location.Y));

            return MeInXmlForm;
        }


        public ArrowStates ArrowState
        {

            get { return LA.ArrowState; }

            set
            {

                LA.ArrowState = value;

            }
        }
        

        //void Connector_Paint(object sender, PaintEventArgs e)
        //{


        //    base.OnPaint(e);

        //    LA.Refesh(e.Graphics);

        //    //Refresh();

        //    e.Graphics.Dispose();
        //}

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            //e.Graphics.DrawLine(new Pen(Color.Black, 3), 0, 40, 20, 40);

            Graphics g = e.Graphics;

            //g.DrawLine(new Pen(Color.Black, 3), 0, 40, 20, 40);

            LA.Refresh(g);

            //dr(g);

            g.Dispose();
        }

        //void dr(Graphics g) {

        //    g.DrawLine(new Pen(Color.Black, 3), 0, 40, 20, 40);
        
        //}


        public override string Text {

            get {

                return lblNote.Text;
            
            }

            set {

                lblNote.Text = value;
            
            }
        
        }

        //void Connector_SizeChanged(object sender, EventArgs e)
        //{
        //    SetOr();

        //    //SetCtrlAlign();
        //}

        public void SwitchOrientation() {

            if (SetOr == HorisontalOr)
            {

                SetOr = VirticalOr;
                CheckVirtHorisInBounds = CheckInboundsY;
                LA.Horisontal = false;

            }
            else
            {

                SetOr = HorisontalOr;
                CheckVirtHorisInBounds = CheckInboundsX;
                LA.Horisontal = true;


            }

            SetOr();

            CheckVirtHorisInBounds();

            Refresh();

        }

        public bool HOrientation()
        {

            if (SetOr == HorisontalOr)
            {

                return true;

            }
            else
            {

                return false;


            }

        }

        void ResetMinSize() {

            MinimumSize = new Size(0, 0);
        
        }

        void VirticalOr() {

            ResetMinSize();

            lblNote.SizeChanged -= new EventHandler(lblNote_SizeChanged);

            //int ILength = Width;

            SuspendLayout();

            //SizeChanged -= new EventHandler(Connector_SizeChanged);

            //Height = Width;

            UpdateDimention = UpdateHeight;

            SetlblResizeAction = VirticalCtrlLocs;

            UpdateDimention();

            //SetConHorisWidth();

            //The height is swapped in and out when the mode is switched

            //Height //= ILength;

  

            //Place Label and Buttons

            

            SetConHorisWidth();

            

            ResumeLayout();

            lblNote.SizeChanged += new EventHandler(lblNote_SizeChanged);
            
        }

        void SetMinimumSizeY() {

            ConMinSize = NP.Location.Y + NP.Height + InterButtonBuffer;

            MinimumSize = new Size(0, ConMinSize);
        
        }

        void HorisontalOr()
        {
            ResetMinSize();

            lblNote.SizeChanged -= new EventHandler(lblNote_SizeChanged);

            //int ILength = Height;

            SuspendLayout();

            Height = HHieght;

            UpdateDimention = UpdateWidth;

            SetlblResizeAction = HorisontalCtrlLocs;

            UpdateDimention();

            //SizeChanged -= new EventHandler(Connector_SizeChanged);

           

            //The width is swapped in and out when the mode is switched 

            //Width = ILength;



            //Place Label and Buttons

            HorisSetControlsOtherThanlbl();

            //HorisontalCtrlLocs();

            ResumeLayout();

            lblNote.SizeChanged += new EventHandler(lblNote_SizeChanged);

            //SizeChanged += new EventHandler(Connector_SizeChanged);

        }

        void SetMinimumSizeX()
        {

            ConMinSize = NP.Location.X + NP.Width + InterButtonBuffer;

            MinimumSize = new Size(ConMinSize, 0);

        }

        //Place controls virtically

        void VirticalCtrlLocs() {

            //lblNote.Location = new Point(Width / 2 + InterButtonBuffer, Height / 2 - lblNote.Height / 2);

            //TODO: V and H Centre nodes
            //Width = lblNote.Location.X + lblNote.Width; //+ (HHieght / 2 - lblNote.Width);



            lblNote.Location = new Point(HHieght / 2 + InterButtonBuffer, SetlblPostionInForm(lblNote.Height, Height));

            //Width = lblNote.Location.X + lblNote.Width + InterButtonBuffer;

            //VirtSetControlsOtherThanlbl();
            
        
        }

        void VirtSetControlsOtherThanlbl() {

            //Width - InterButtonBuffer - DN.Width

            //lblNote.Location.X + lblNote.Width - DN.Width

            //DN.Location = new Point(Width - InterButtonBuffer - DN.Width, InterButtonBuffer);

            //NM.Location = new Point(Width - InterButtonBuffer - DN.Width, DN.Location.Y + NM.Height + InterButtonBuffer);

            //RN.Location = new Point(Width - InterButtonBuffer - DN.Width, NM.Location.Y + DN.Height + InterButtonBuffer);

            //NP.Location = new Point(Width - InterButtonBuffer - DN.Width, RN.Location.Y + RN.Height + InterButtonBuffer);

            DN.Location = new Point(HHieght - InterButtonBuffer - DN.Width, InterButtonBuffer);

            NM.Location = new Point(HHieght - InterButtonBuffer - DN.Width, DN.Location.Y + NM.Height + InterButtonBuffer);

            RN.Location = new Point(HHieght - InterButtonBuffer - DN.Width, NM.Location.Y + DN.Height + InterButtonBuffer);

            NP.Location = new Point(HHieght - InterButtonBuffer - DN.Width, RN.Location.Y + RN.Height + InterButtonBuffer);

            SetMinimumSizeY();
        
        }

        // Place controls horisontally

        void HorisontalCtrlLocs() {

            //HorisSetControlsOtherThanlbl();

            //lblNote.Location = new Point(NP.Location.X + NP.Width + InterButtonBuffer, InterButtonBuffer);  /*Width / 2 - lblNote.Width / 2*/

            //lblNote.Location = new Point(SetlblPostionInForm(lblNote.Width, Width), InterButtonBuffer);

            lblNote.Location = new Point(SetlblPostionInForm(lblNote.Width, ConWidth), InterButtonBuffer);

        }

        void HorisSetControlsOtherThanlbl() {

            DN.Location = new Point(InterButtonBuffer, InterButtonBuffer);

            NM.Location = new Point(DN.Location.X + DN.Width + InterButtonBuffer, InterButtonBuffer);

            RN.Location = new Point(NM.Location.X + NM.Width + InterButtonBuffer, InterButtonBuffer);

            NP.Location = new Point(RN.Location.X + RN.Width + InterButtonBuffer, InterButtonBuffer);

            SetMinimumSizeX();

        }

        void lblNote_SizeChanged(object sender, EventArgs e)
        {
            SetlblResizeAction();
            UpdateHorisForm();
        }

        //Sets the labels Position at an equil distance between the left or bottom most button and the left or bottom most edge of the container   

        int SetlblPostionInForm(int LabelDimention, int ContDimention)
        {
            //int PL = InnerButtonLocation + InnerButtonDimention;

            //return ((((ContDimention - PL) / 2) - LabelDimention / 2) + PL);

            return ((ContDimention / 2) - LabelDimention / 2);
        
        }

        protected override void OnMouseEnter(EventArgs e)
        {
            OrganiseLastSelectedControl(e);
        }

        public void OrganiseLastSelectedControl(EventArgs e)
        {

            //NodeContainer NC = (NodeContainer)Parent;

            NodeDocumentSurface NC = (NodeDocumentSurface)Parent;

            if (this != NC.ControlLast)
            {

                if (NC.ControlLast != null)
                    NC.ControlLast.HideChildren();

                if (!AreChildButtonsVisible)
                    ShowChildren();

                NC.ControlLast = this;

                base.OnMouseEnter(e);
            }
        
        }

        public void ShowChildren()
        {

            SetChildVisibleState(true);

        }

        public void HideChildren()
        {

            SetChildVisibleState(false);

        }

        public void SetChildVisibleState(bool state)
        {

            foreach (Control c in Controls)
            {
                if (c.GetType() != typeof(Label))
                    c.Visible = state;

                AreChildButtonsVisible = state;
            }
        }

        public void ChangeLabelVisibleState() {

            lblNote.Visible = !lblNote.Visible;

            if (lblNote.Visible)
                SetConHorisWidth = WithLabel;
            else
                SetConHorisWidth = NoLabel;

            UpdateHorisForm();
        }

        void NoLabel() {

            Width = HHieght;

            VirtSetControlsOtherThanlbl();
        
        }

        void WithLabel() {

            int NewWidth = lblNote.Location.X + lblNote.Width;

            if (SetOr == VirticalOr)

                if (NewWidth > HHieght)
                {
                    Width = NewWidth;

                }
                else {

                    Width = HHieght;

                }

            VirtSetControlsOtherThanlbl();
        }

        public bool LabelVisibleState
        {

            get { return lblNote.Visible; }

        }

        public void Highlight() {

            LA.Pen = new Pen(Color.Gold, 3);
        
        }

        void UpdateHorisForm() {

            if (SetOr == VirticalOr)
                SetConHorisWidth();
        
        }

        public void UnHighlight()
        {

            LA.Pen = new Pen(Color.Black, 3);

        }

        public int TheAllowedDrawingWidth {

            get { return HHieght; }
        
        }

        public int TheAllowedDrawingHeight
        {

            get { return ConWidth; }

            set { ConWidth = value;

            UpdateDimention();

            }

        }

        public int TheMinSize {

            get { return ConMinSize; }
        
        }

        void UpdateHeight() {

            Height = ConWidth;

            //NMTopLeft.CurrentlyHorisontal = false;

            NMBottomRight.CurrentlyHorisontal = false;

            //NMTopLeft.Location = new Point(SetlblPostionInForm(NMTopLeft.Width, HHieght), InterButtonBuffer);

            NMBottomRight.Location = new Point(SetlblPostionInForm(NMBottomRight.Width, HHieght), Height - NMBottomRight.Height - InterButtonBuffer);

            if (Height > MinimumSize.Height)
                SetlblResizeAction();

        }

        void UpdateWidth()
        {

            Width = ConWidth;

            //NMTopLeft.CurrentlyHorisontal = true;

            NMBottomRight.CurrentlyHorisontal = true;

            //NMTopLeft.Location = new Point(InterButtonBuffer, SetlblPostionInForm(NMTopLeft.Height, Height));

            NMBottomRight.Location = new Point(Width - NMBottomRight.Width - InterButtonBuffer, SetlblPostionInForm(NMBottomRight.Height, Height));

            if (Width > MinimumSize.Width)
                SetlblResizeAction();

        }

        public void SetSizeInParentBounds()
        {
            CheckVirtHorisInBounds();
        }

        void CheckInboundsX()
        {
            CheckInbounds(Location.X, Size.Width, Parent.Width);
            //int XLocation = Location.X + Size.Width;

            //bool H = IsOverBounds(Parent.Size.Width, XLocation);

            //if (H)
            //{

            //    Size = new Size(ShrinkNode(Parent.Size.Width, XLocation, Size.Width), Size.Height);

            //    Refresh();
            //}
            //UpdateWidth();
            //SetlblResizeAction();

            NMBottomRight.Location = new Point(Width - NMBottomRight.Width - InterButtonBuffer, SetlblPostionInForm(NMBottomRight.Height, Height));

            //if (Width > MinimumSize.Width)
                SetlblResizeAction();


            //UpdateWidth()
        }

        void CheckInboundsY()
        {
            CheckInbounds(Location.Y, Size.Height, Parent.Height); //Error!
            //int YLocation = Location.Y + Size.Height;

            //bool V = IsOverBounds(Parent.Size.Height, YLocation);
            UpdateHeight();
            //if (V)
            //{

            //    Size = new Size(Size.Width, ShrinkNode(Parent.Size.Height, YLocation, Size.Height));

            //    Refresh();
            //}

        }

        void CheckInbounds(int ConnectorLD, int ConnectorSD, int ParentSD)
        {

            int NewLocation = ConnectorLD + ConnectorSD;

            bool IsOverTheBounds = IsOverBounds(ParentSD, NewLocation);

            if (IsOverTheBounds)
            {

                if (CheckVirtHorisInBounds == CheckInboundsX)
                {

                    Width = ShrinkNode(ParentSD, NewLocation, ConnectorSD);
                    ConWidth = Width;

                } else
                {
                    Height = ShrinkNode(ParentSD, NewLocation, ConnectorSD);
                    ConWidth = Height;
                }

                Refresh();
            }

        }

        int ShrinkNode(int TotalLoc, int LocationOver, int ParentsSize)
        {
            int Offset = TotalLoc - LocationOver;

            return ParentsSize + Offset - 1;

        }

        bool IsOverBounds(int ParentParentWidth, int LocationAndSize)
        {

            return ParentParentWidth < LocationAndSize;

        }


        //~Connector() { Console.WriteLine("Cleaned Up");  }

    }

    public enum ArrowStates
    { 
    
        TopOrLeft, None, BottomOrRight

    }

}
