using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//Draws aline or and arrow both horisontally and vertaically based on what has
//been

namespace SimpleFlowDesigner
{
    class LineArrow
    {


        delegate void Gr(Graphics g);

        //Draws the just the line or the line and arrow

        Gr Draw; // can only be assined DrawLineOnly or DrawArrowAndLine.

        //Responsible for drawing both the arrow and the line itself if an arrow option has been selected

        //Responsible for drawing the line regardless of orientation.

        Gr DrawLine; //Can only be assigned

        //Responsible for drawing the arrow regardless of the lines' orientation

        //

        Gr DrawArrow;

        //Responsible for drawing the line regardless of the lines' orientation
        //It is never disabled


        //

        //Resposibe for drawing either the bottom or right arrow depending on whether or not it is horisontal or not 

        Gr DrawBottomOrRight;

        // Same as above except for Top or Left;

        Gr DrawTopOrLeft;

        Pen ThePen = new Pen(Color.Black, 3);

        static int ArrowBranchLength = 10;

        Connector Parent;

        ArrowStates AS;

        bool isHorisontal = true;

        public LineArrow(Connector Parent) {

            this.Parent = Parent;

            AS = ArrowStates.None;

            Draw = DrawLineOnly;

            SetOrientation();

            //Parent.Refresh();
        
        }

        public ArrowStates ArrowState
        {

            get { return AS; }

            set
            {

                AS = value;

                switch (AS)
                {

                    case ArrowStates.BottomOrRight:

                        DrawArrow = DrawBottomOrRight;

                        Draw = DrawArrowAndLine;

                        break;

                    case ArrowStates.None:

                        Draw = DrawLineOnly;

                        break;

                    case ArrowStates.TopOrLeft:

                        DrawArrow = DrawTopOrLeft;

                        Draw = DrawArrowAndLine;

                        break;

                }

                Parent.Refresh();
               
            }

        }

        public bool Horisontal {

            get { return isHorisontal; }

            set { 
                
                  isHorisontal = value;

                  SetOrientation();
            
            }
        
        
        }

        //201207 So arrow states are not transative... What a waste of time... 

        void SetOrientation() {

            if (!isHorisontal)
            {

                DrawLine = NoArrowV;

                DrawBottomOrRight = BottomArrow;

                DrawTopOrLeft = TopArrow;

            }

            else
            {
                DrawLine = NoArrowH;

                DrawBottomOrRight = RightArrow;

                DrawTopOrLeft = LeftArrow;

            }

            ArrowState = ArrowState;

            Parent.Refresh();


        }

        //public LineArrow() { }

        public void Refresh(Graphics g)
        {
            //g.DrawLine(ThePen, 150, 0, 150, Parent.Height);

            Draw(g); 
        
        }

        void NoArrowH(Graphics g)
        {

            //int W = Origin(Parent.Height);

            int W = Origin(Parent.TheAllowedDrawingWidth);

            g.DrawLine(ThePen, 0, W, Parent.TheAllowedDrawingHeight, W);

            //g.DrawLine(ThePen, 0, W, Parent.Width, W);

        }

        void NoArrowV(Graphics g)
        {

            //int H = Origin(Parent.Width);

            int H = Origin(Parent.TheAllowedDrawingWidth);

            g.DrawLine(ThePen, H, 0, H, Parent.TheAllowedDrawingHeight);

            //g.DrawLine(ThePen, 0, W, Parent.TheAllowedDrawingHeight, W);

            //g.DrawLine(ThePen, H, 0, H, Parent.Height);

        }

        //The next four methods must only be used with the above two.

        void LeftArrow(Graphics g)
        {

            //int Or = Origin(Parent.Height);

            //g.DrawLine(ThePen, 0, Or, ArrowBranchLength, Or - ArrowBranchLength);
            //g.DrawLine(ThePen, 0, Or, ArrowBranchLength, Or + ArrowBranchLength);

            int Or = Origin(Parent.TheAllowedDrawingWidth);

            g.DrawLine(ThePen, 0, Or, ArrowBranchLength, Or - ArrowBranchLength);
            g.DrawLine(ThePen, 0, Or, ArrowBranchLength, Or + ArrowBranchLength);

        }

        void TopArrow(Graphics g)
        {

            //int Or = Origin(Parent.Width);

            int Or = Origin(Parent.TheAllowedDrawingWidth);

            g.DrawLine(ThePen, Or, 0, Or - ArrowBranchLength, ArrowBranchLength);
            g.DrawLine(ThePen, Or, 0, Or + ArrowBranchLength, ArrowBranchLength); 

        }

        void RightArrow(Graphics g)
        {

            //int Or = Origin(Parent.Height);

            int Or = Origin(Parent.TheAllowedDrawingWidth);


            g.DrawLine(ThePen, Parent.TheAllowedDrawingHeight, Or, Parent.TheAllowedDrawingHeight - ArrowBranchLength, Or - ArrowBranchLength);
            g.DrawLine(ThePen, Parent.TheAllowedDrawingHeight, Or, Parent.TheAllowedDrawingHeight - ArrowBranchLength, Or + ArrowBranchLength); 

            //g.DrawLine(ThePen, Parent.Width, Or, Parent.Width - ArrowBranchLength, Or - ArrowBranchLength);
            //g.DrawLine(ThePen, Parent.Width, Or, Parent.Width - ArrowBranchLength, Or + ArrowBranchLength);  

        }

        void BottomArrow(Graphics g)
        {

            //int Or = Origin(Parent.Width);

            int Or = Origin(Parent.TheAllowedDrawingWidth);


            g.DrawLine(ThePen, Or, Parent.TheAllowedDrawingHeight, Or - ArrowBranchLength, Parent.TheAllowedDrawingHeight - ArrowBranchLength);
            g.DrawLine(ThePen, Or, Parent.TheAllowedDrawingHeight, Or + ArrowBranchLength, Parent.TheAllowedDrawingHeight - ArrowBranchLength); 

            //g.DrawLine(ThePen, Or, Parent.Height, Or - ArrowBranchLength, Parent.Height - ArrowBranchLength);
            //g.DrawLine(ThePen, Or, Parent.Height, Or + ArrowBranchLength, Parent.Height - ArrowBranchLength); 

        }

        int Origin(int PointEnd) {

            return PointEnd / 2;

        }

        void DrawLineOnly(Graphics g)
        {

            DrawLine(g);

        }

        void DrawArrowAndLine(Graphics g)
        {

            DrawLine(g);

            DrawArrow(g);

        }

        public Pen Pen {

            get { return ThePen; }

            set { ThePen = value; Parent.Refresh(); }
        
        }

    }
}
