﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class DocumentContainer : Panel
    {
        delegate void DoTheSize();

        DoTheSize ResizeDoc;

        NodeDocument ND = new NodeDocument();

        NodeToolBar NTB;

        public DocumentContainer() {

            //Size = new Size(600, 200);

            NTB = new NodeToolBar(ND);

            Controls.Add(NTB);

            Controls.Add(ND);

            //AutoScroll = true;
            //NTB.Height = 49;
            //NTB.Width = Width; 

            //Height = Height - NTB.Height; 

            //SizeChanged += new EventHandler(SimpleFlowDesignerMain_SizeChanged);

            BorderStyle = BorderStyle.FixedSingle;

            //ND.SetSize();

            //ND.NewDocument();

            //NTB.Visible = true;

            //NTB.Visible = false;

            Name = "NewDocument";

            ResizeDoc = SetSizeUnderBar;

            ResizeDoc();
        }

        //void SimpleFlowDesignerMain_SizeChanged(object sender, EventArgs e) {

        //    ResizeDoc();

        //    //ND.SetSize();

        //}

        public void SetSize() {

            SetThisSize();

            ResizeDoc();

        }

        public void RestDocSize()
        {

            ResizeDoc();

        }

        void SetThisSize()
        {

            Size = new Size(Parent.Width - 8, Parent.Height - 58);

        }

        void SetSizeFull() {

            ND.Location = new Point(0, 0);

            ND.Size = new Size(Parent.Width, Parent.Height /*- Location.Y*/);

        }

        void SetSizeUnderBar() {

            ND.Location = new Point(0, NTB.Location.Y + NTB.Height);

            ND.Size = new Size(Width, Height - Location.Y /*- NTB.Height - 26*/);

        }

        public bool NodeToolBarHidden {

            get { return NTB.Visible; }

            set {

                if (value)
                {

                    ResizeDoc = SetSizeFull;

                } else {


                    ResizeDoc = SetSizeUnderBar;
                }

                NTB.Visible = value;
            }
        
        }

        public void NewDocument() {

            ND.NewDocument();

        }

        public void ShowResizeDialouge()
        {

            ND.ShowResizeDialogue();

        }

        public XElement GetAllNodesXml()
        {
            Control NDS = ND.Controls[0];

            XElement Document = new XElement(Name, new XElement("Settings", new XAttribute("Width", NDS.Width), new XAttribute("Height", NDS.Height)));        

            foreach (Control Node in NDS.Controls)
                Document.Add(((ISaveMyself)Node).ProfileMe());

            return Document;
        }

        //100608 Whoopsie!
        //public List<XElement> GetAllNodesXml()
        //{
        //    List<XElement> NodeList = new List<XElement>();

        //    foreach (XElement Node in NodeList)
        //        NodeList.Add(Node);

        //    return NodeList;
        //}

        public void LoadDoc(XElement doc)
        {

            ND.LoadDoc(doc);

            //IEnumerable<XElement> docEls = doc.Elements();

            //Name = doc.Name.ToString();

            //foreach (XElement Node in docEls)
            //{

            //    switch (Node.Name.ToString())
            //    {

            //        case "TerminalNode":

            //            break;

            //        case "ProcessNode":

            //            break;
                    
            //        case "DecisionNode":

            //            break;

            //        case "InputOutPutNode":

            //            break;

            //        case "PreDefinedProcessNode":

            //            break;

            //        case "Connector":

            //            break;
            //    }

            }

        }

    }

