using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    public partial class SimpleFlowDesignerMain : Form //, IHideToolBar
    {
        //NodeContainer Document = new NodeContainer();

        //NodeDocument Document = new NodeDocument();

        //NodeToolBar TS;

        DocumentContainer DC = new DocumentContainer();

        AboutForm AF = new AboutForm();

        string CurrentDocSaveDir;

        string DocumentName;

        public SimpleFlowDesignerMain()
        {
            //TS = new NodeToolBar(Document);

            //Controls.Add(TS);

            InitializeComponent();
            //FormBorderStyle = FormBorderStyle.None;
            //TS.Location = new Point(0, 24);

            BackColor = SystemColors.Control;

            DC.Location = new Point(0, menuStrip1.Location.Y + menuStrip1.Height);

            Controls.Add(DC);
            //BackColor = Color.Sienna;
            //SetSize();

            //AutoScroll = true;

            //DC.SetSize();

            //DC.RestDocSize();

            //DC.NewDocument();

            //Document.NewDocument();

            //Document.AddConnector();

            //Document.AddProcessNode();

            //Document.AddDecisionNode();

            //Document.AddInputOutPutNode();

            //Document.AddPreDefinedProcessNode();

            Resize += new EventHandler(SimpleFlowDesignerMain_Resize);

            DC.SetSize();

            DC.NewDocument();

            customizeToolStripMenuItem.MouseDown += new MouseEventHandler(customizeToolStripMenuItem_MouseDown);

            Tag = Text;

            AF.Visible = false;

            //Size = new Size(800, 800);

        }

        void customizeToolStripMenuItem_MouseDown(object sender, MouseEventArgs e)
        {
            DC.ShowResizeDialouge();
        }

        void SimpleFlowDesignerMain_Resize(object sender, EventArgs e)
        {

            DC.SetSize();

        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if(CurrentDocSaveDir != null)

                SaveDoc(CurrentDocSaveDir);

            else

                SaveDocAs();
        }

        void SaveDoc(string FileName)
        {
            try
            {

                XElement NodeXmlcollection = DC.GetAllNodesXml();

                XDocument doc = new XDocument(new XDeclaration("1.0", "utf-8", "yes"), new XComment("Created On: " + DateTime.Now.ToString()), new XComment("Document produced using SimpleFlowDesigner, concived and developed by Paul Saunders - 2008"));

                doc.Add(NodeXmlcollection);

                doc.Save(FileName);

            } catch {

                MessageBox.Show("Technicalities were experienced while saving the current document.", "Error");
            }

        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {

            OpenFileDialog openFileDialogue = new OpenFileDialog();
            XDocument doc;

            //openFileDialogue.InitialDirectory = "c:\\XmlDocs";
            openFileDialogue.Filter = "xml files (*.xml)|*.xml";
            openFileDialogue.RestoreDirectory = true;

            if (openFileDialogue.ShowDialog() == DialogResult.OK)
            {

                doc = XDocument.Load(openFileDialogue.FileName);

                DC.NewDocument();

            try
            {
                DC.LoadDoc(doc.Root);

                SetDocTitle(doc.Root.Name.ToString());

            } catch {

                MessageBox.Show("Technicalities were experienced while opening the selected document.", "Error");
            }

                CurrentDocSaveDir = openFileDialogue.FileName;

            }

        }

        void SetDocTitle(string docName)
        {

            DC.Name = docName;

            Text = Tag.ToString() + " - " + docName;

        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {

            SaveDocAs();

        }

        void SaveDocAs()
        {

            SaveFileDialog saveFileDialogue = new SaveFileDialog();
            //XDocument doc;

            //saveFileDialogue.InitialDirectory = "c:\\SFDSaves";
            saveFileDialogue.Filter = "xml files (*.xml)|*.xml";
            //saveFileDialogue.RestoreDirectory = true;

            saveFileDialogue.FileName = DC.Name + ".xml";

            if (saveFileDialogue.ShowDialog() == DialogResult.OK)
            {
                DocumentName = getDocName(saveFileDialogue.FileName);

                DC.Name = DocumentName;

                SetDocTitle(DocumentName);

                SaveDoc(saveFileDialogue.FileName);

            }

            //CurrentDocSaveDir = saveFileDialogue.FileName;

        }

        string getDocName(string DirectoryName) {

            int LastForwardSlash = DirectoryName.LastIndexOf('\\') + 1;

            //int LFSLength = DirectoryName.Length - LastForwardSlash - 1;

            DirectoryName = DirectoryName.Remove(0, LastForwardSlash);

            int DotLocation = DirectoryName.LastIndexOf('.');

            DirectoryName = DirectoryName.Remove(DotLocation, 4);

            return DirectoryName;
        
        
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (CurrentDocSaveDir == null)
            {
                if (MessageBox.Show("You have yet to save your document. Would now be a good time?", "Save Document", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    SaveDocAs();
                else
                {
                    DC.NewDocument();
                    ResetTitleText();
                }

            } else
            {
                DC.NewDocument();
                ResetTitleText();
            }
        }

        void ResetTitleText()
        {

            Text = Tag.ToString();

        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            AF.Visible = true;
        }

        //void SetSize()
        //{

        //    DC.Size = new Size(Width - 8, Height - (menuStrip1.Location.Y + menuStrip1.Height) - 34);

        //}

        //protected override void OnResize(EventArgs e)
        //{
        //    base.OnResize(e);

        //    DC.SetSize();
        //}

        //public void HideToolBar() { Document.Hide(); }

        //public void RevealToolBar() { Document.Show(); }

    }
}