﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace SimpleFlowDesigner
{
    public class NodeDocumentSurface : Panel
    {

        IHideShowChildren LastControl;

        NDSResize ResizeDialouge;

        public NodeDocumentSurface() {

            SuspendLayout();

            //BackColor = Color.Chocolate;

            BackColor = Color.White;

            ControlAdded += new ControlEventHandler(Document_ControlAdded);

            ResumeLayout();
            //AutoScroll = true;

            MinimumSize = new Size(400, 400);

            Size = new Size(600, 600);

            ResizeDialouge = new NDSResize(this);
        
        }

        int CentralLoc(int ContnrSize, int ContndSize)
        {

            return ContnrSize / 2 - ContndSize / 2;
        }

        void Document_ControlAdded(object sender, ControlEventArgs e)
        {
            ProcessObject PO = (ProcessObject)e.Control;

            PO.Location = new Point(CentralLoc(Parent.Width, e.Control.Width), CentralLoc(Parent.Height, e.Control.Height));

            PO.TestIfOutOfDocBounds();
        }


        public void DocArrangeTNodes()
        {

            SuspendLayout();

            ResumeLayout();
        }

        public void NewDocument()
        {

            if (Controls.Count > 0)
                Controls.Clear();

                ControlAdded -= new ControlEventHandler(Document_ControlAdded);

                Controls.Add(new TerminalNode());

                Controls.Add(new TerminalNode());

                Controls[0].Location = new Point(CentralLoc(Width, Controls[0].Width), CentralLoc(Height, Controls[0].Height * 2));

                Controls[1].Location = new Point(CentralLoc(Width, Controls[1].Width), Controls[0].Location.Y + Controls[0].Height);

                ControlAdded += new ControlEventHandler(Document_ControlAdded);

                ((TerminalNode)Controls[0]).CompletedTNodeCreation();

        }

        public void AddProcessNode() { Controls.Add(new ProcessNode()); }

        public void AddDecisionNode() { Controls.Add(new DecisionNode()); }

        public void AddInputOutPutNode() { Controls.Add(new InputOutPutNode()); }

        public void AddPreDefinedProcessNode() { Controls.Add(new PreDefinedProcessNode()); }

        public void AddConnector() { Controls.Add(new Connector()); }

        public IHideShowChildren ControlLast
        {

            get
            {

                return LastControl;
            }

            set
            {

                LastControl = value;

            }

        }

        protected override void OnMouseEnter(EventArgs e)
        {
            if (LastControl != null)
            {

                LastControl.HideChildren();

                LastControl = null;

            }

            base.OnMouseEnter(e);

        }

        public void ShowResizeDialougue() {

            ResizeDialouge.Visible = true;
        
        }

    }
}
