using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace SimpleFlowDesigner
{

    //010108 I had orginally intended this class to inherit from NodeMove.
    //       I have scince determaned that this is not viable.

    class ConnectorResize : NodeControl //NodeResize : NodeControl
    {

        delegate void Gr(Graphics g);

        delegate void NewParentSize(ref int PosXInPN, ref int PosYInPN);

        delegate void SetHorisontalOrVertical();

        delegate void CurrentPosInPanel(MouseEventArgs e);

        delegate int TheCurrentPosInPanel(MouseEventArgs e);

        //SetHorisontalOrVertical SetSettings;

        Gr DrawArrow;

        CurrentPosInPanel SetLastPostition;

        CurrentPosInPanel GrowShrink;

        protected int LastPosX;
        protected int LastPosY;

        bool Horisontal;

        static GraphicsPath LeftArrow = new GraphicsPath();
        static GraphicsPath RightArrow = new GraphicsPath();
        static GraphicsPath UpArrow = new GraphicsPath();
        static GraphicsPath DownArrow = new GraphicsPath();

        static bool PointsSet = false;

        SolidBrush B;

        //NewParentSize = 

        //GraphicsPath Up = new GraphicsPath(


        public ConnectorResize()
        {

            BackColor = SystemColors.Window;

            B = new SolidBrush(ForeColor);

            Size = new Size(20, 20);

            CurrentlyHorisontal = true;

            SetPoints();

        }

        void SetPoints()
        {

            if (!PointsSet)
            {

                int HalfWidth = HalfOf(Width);
                int HalfHeight = HalfOf(Height);

                Point[] LAset = { new Point(HalfWidth - 1, 0), new Point(1, HalfHeight), new Point(HalfWidth, Height) };

                Point[] RAset = { new Point(HalfWidth + 1, 0), new Point(Width, HalfHeight), new Point(HalfWidth, Height) };

                Point[] UAset = { new Point(0, HalfHeight - 1), new Point(HalfWidth, 0), new Point(Width, HalfHeight) };

                Point[] DAset = { new Point(0, HalfHeight + 1), new Point(HalfWidth, Height), new Point(Width, HalfHeight) };

                LeftArrow.AddLines(LAset);
                RightArrow.AddLines(RAset);
                UpArrow.AddLines(UAset);
                DownArrow.AddLines(DAset);

                PointsSet = true;

            }

        }

        static int HalfOf(int ToBeHalved)
        {

            return ToBeHalved / 2;

        }
        
        public bool CurrentlyHorisontal {

            get { return Horisontal; }

            set {

                if (value) {

                    GrowShrink = GrowShrinkX;

                    SetLastPostition = SetLastPositionX;

                    DrawArrow = LeftRightArrows;
                
                } 
                else {

                    GrowShrink = GrowShrinkY;

                    SetLastPostition = SetLastPositionY;

                    DrawArrow = TopBottomArrows;

                }

                Horisontal = value;
                
                Refresh();
                
            }
        
        }

        protected override void OnMouseUp(MouseEventArgs mevent)
        {
            base.OnMouseUp(mevent);

            MouseMove -= new MouseEventHandler(NodeMove_MouseMove);

            ((IHideShowChildren)Parent).SetSizeInParentBounds();
        }

        protected override void OnMouseDown(MouseEventArgs mevent)
        {
            base.OnMouseDown(mevent);

            MouseMove += new MouseEventHandler(NodeMove_MouseMove);

            SetLastPostition(mevent);

        }

        void SetLastPositionX(MouseEventArgs e) {

            LastPosX = CurrentXPosInPanel(e);

        }

        void SetLastPositionY(MouseEventArgs e)
        {
            LastPosY = CurrentYPosInPanel(e);

        }

        protected override void OnPaint(PaintEventArgs pevent)
        {
            base.OnPaint(pevent);

            //Graphics g = pevent.Graphics;

            DrawArrow(pevent.Graphics);
        }

        protected void NodeMove_MouseMove(object sender, MouseEventArgs e)
        {

            GrowShrink(e);

            //int NewLoc;
            //int PosInPN;

            //RetainMousePosition(out NewLoc, out PosInPN, Parent.Location.X, ref LastPosX, CurrentXPosInPanel, e);

            ////Parent.Location = new Point(NewLocX, NewLocY);

            //SetLastPosition(ref PosInPN);

            //System.Console.WriteLine("\nX: " + NewLocX);
            //System.Console.WriteLine("Y: " + NewLocY);

            //Redraw affected lines
        }

        void GrowShrinkX(MouseEventArgs e)
        {
            Connector TheParent = (Connector)Parent;

            int PosInPN;

            RetainMousePosition(TheParent, out PosInPN, ref LastPosX, CurrentXPosInPanel, e);

            //Parent.Location = new Point(NewLocX, NewLocY);

            SetLastPosition(ref LastPosX, ref PosInPN);
        
        }

        void GrowShrinkY(MouseEventArgs e)
        {

            Connector TheParent = (Connector)Parent;

            int PosInPN;

            RetainMousePosition(TheParent, out PosInPN, ref LastPosY, CurrentYPosInPanel, e);

            //Parent.Location = new Point(NewLocX, NewLocY);

            SetLastPosition(ref LastPosY, ref PosInPN);
        }

        protected void SetLastPosition(ref int LastPos, ref int PosInPN)
        {
            LastPos = PosInPN;

        }

        void RetainMousePosition(Connector TheParent, out int PosInPN, ref int LastPos, TheCurrentPosInPanel CurrentPos, MouseEventArgs e)
        {
            int TheNewSize; //TheMinSize

            PosInPN = CurrentPos(e);

            TheNewSize = (TheParent.TheAllowedDrawingHeight + (PosInPN - LastPos));

            if (TheNewSize >= TheParent.TheMinSize)
            {
                TheParent.TheAllowedDrawingHeight = TheNewSize;

                Parent.Refresh();
            }

        }

        void LeftRightArrows(Graphics g)
        {
            //Pen p = new Pen(ForeColor);

            //g.DrawLine(p, 0, 0, Width, Height);
            
            g.FillPath(B, LeftArrow);

            g.FillPath(B, RightArrow);

        }

        void TopBottomArrows(Graphics g)
        {
            g.FillPath(B, UpArrow);

            g.FillPath(B, DownArrow);

        }

        int CurrentXPosInPanel(MouseEventArgs e)
        {

            return Parent.Location.X + Location.X + e.X;

        }

        int CurrentYPosInPanel(MouseEventArgs e)
        {

            return Parent.Location.Y + Location.Y + e.Y;

        }

    }
}
