using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public class NodeMove : NodeControl
    {
        protected int LastPosX;
        protected int LastPosY;

        public NodeMove() {

        Text = "+";

        //MouseUp += new MouseEventHandler(NodeMove_MouseUp);
        //MouseDown += new MouseEventHandler(NodeMove_MouseDown);

        }

        protected override void OnMouseUp(MouseEventArgs mevent)
        {
            base.OnMouseUp(mevent);

            MouseMove -= new MouseEventHandler(NodeMove_MouseMove);

            ((ProcessObject)Parent).TestIfOutOfDocBounds();
        }

        protected override void OnMouseDown(MouseEventArgs mevent)
        {
            base.OnMouseDown(mevent);

            MouseMove += new MouseEventHandler(NodeMove_MouseMove);

            LastPosX = CurrentXPosInPanel(mevent);
            LastPosY = CurrentYPosInPanel(mevent);
        }

        //void NodeMove_MouseUp(object sender, MouseEventArgs e)
        //{
        //    MouseMove -= new MouseEventHandler(NodeMove_MouseMove);
        //}

        //void NodeMove_MouseDown(object sender, MouseEventArgs e)
        //{
        //    MouseMove += new MouseEventHandler(NodeMove_MouseMove);

        //    //Mouse Positions on the button must be accounted for

        //    //MousePosInButtonX = e.X;
        //    //MousePosInButtonY = e.Y;

        //    LastPosX = CurrentXPosInPanel(e);
        //    LastPosY = CurrentYPosInPanel(e);
        //}

        protected virtual void NodeMove_MouseMove(object sender, MouseEventArgs e)
        {
            //Button SB = (Button)sender;
            //The original position in the button must be noted and accounted for 

            //int PosXInPN = CurrentXPosInPanel(e);
            //int PosYInPN = CurrentYPosInPanel(e);

            //int NewLocX = (Parent.Location.X + (PosXInPN - LastPosX));
            //int NewLocY = (Parent.Location.Y + (PosYInPN - LastPosY));

            int NewLocX;
            int NewLocY;
            int PosXInPN;
            int PosYInPN;

            //RetainMousePosition(out NewLocX, out NewLocY, out PosXInPN, out PosYInPN, e);

            PosXInPN = CurrentXPosInPanel(e);
            PosYInPN = CurrentYPosInPanel(e);

            NewLocX = (Parent.Location.X + (PosXInPN - LastPosX));
            NewLocY = (Parent.Location.Y + (PosYInPN - LastPosY));

            Parent.Location = new Point(NewLocX, NewLocY);

            SetLastPosition(ref PosXInPN, ref PosYInPN);

            //System.Console.WriteLine("\nX: " + NewLocX);
            //System.Console.WriteLine("Y: " + NewLocY);

            //Redraw affected lines
        }

        //protected void RetainMousePosition(out int NewLoc, out int PosInPN, out int ParentLoc, MouseEventArgs e)
        //{

        //    PosXInPN = CurrentXPosInPanel(e);
        //    PosYInPN = CurrentYPosInPanel(e);

        //    NewLocX = (Parent.Location.X + (PosXInPN - LastPosX));
        //    NewLocY = (Parent.Location.Y + (PosYInPN - LastPosY));

        //    PosInPN = CurrentXPosInPanel(e);

        //    NewLocX = (ParentLoc + (PosXInPN - LastPosX));

        //}

        protected void SetLastPosition(ref int PosXInPN, ref int PosYInPN)
        {
            LastPosX = PosXInPN;
            LastPosY = PosYInPN;
        }

        int CurrentXPosInPanel(MouseEventArgs e)
        {

            return Parent.Location.X + Location.X + e.X;
        
        }

        int CurrentYPosInPanel(MouseEventArgs e)
        {

            return Parent.Location.Y + Location.Y + e.Y;

        }

    }
}
