using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    abstract public class EditableTextNode : ResizeableNode, ISaveMyself
    {

        TextEdit TE = new TextEdit();

        DeleteNodeTE DN;

        protected NodeOutLine NO = new NodeOutLine();

        public EditableTextNode() {

            DN = new DeleteNodeTE(TE);

            SizeChanged += new EventHandler(EditableTextNode_SizeChanged);

            Controls.Add(DN);

            Controls.Add(TE);

            SizeControls();
            
        }

        void SizeControls() {

            DN.Location = new Point(Width - DN.Width - SideTopBuffer, SideTopBuffer);

            TE.Location = HWidth(2);

        }

        void EditableTextNode_SizeChanged(object sender, EventArgs e)
        {

            SizeControls();

        }

        protected List<XAttribute> ProfileETNode()
        {

            List<XAttribute> ProfileOfPONode = ProfilePONode();

           ProfileOfPONode.Add(new XAttribute("Text", TE.Text));
            
           return ProfileOfPONode;

        }

        public XElement ProfileMe()
        {

            List<XAttribute> MyAttributes = ProfilePONode();

            XElement MeInXmlForm = new XElement(Name);

            foreach (XAttribute Attribute in MyAttributes)
                MeInXmlForm.Add(Attribute);

            MeInXmlForm.Add(new XAttribute("Text", Text));

            return MeInXmlForm;

        }
    }
}