using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Drawing.Drawing2D;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{

    public abstract class MoveableNode : ProcessObject, IHideShowChildren
    {
        //int LastPosX;
        //int LastPosY;
        //int i;

        //int XDiff;
        //int YDiff;

        //protected static int InterButtonBuffer = 4;

        //protected static int SideTopBuffer = 5;
 
        //protected static int NodeInteriorBuffer = 60;

        //protected delegate Point[] UpdateP();

        //protected UpdateP UpdateThePoints;

        protected delegate void PaintTheForm(PaintEventArgs e);

        //protected PaintTheForm PaintNow;

        protected delegate void SetSize(EventArgs eventargs);

        //protected SetSize SizeNow;

        bool AreChildButtonsVisible;

        protected NodeMove NM = new NodeMove();

        protected int InteriorPadding = 2;

        //protected Pen ForePen;

        //protected GraphicsPath Appearance = new GraphicsPath();

        public MoveableNode() {

            SizeChanged += new EventHandler(MovableNode_SizeChanged);

            Controls.Add(NM);

            //ForePen = new Pen(ForeColor, 3);

            //MouseEnter += new EventHandler(MovableNode_MouseEnter);
            //MouseLeave += new EventHandler(MovableNode_MouseLeave);

            //LocationChanged += new EventHandler(MovableNode_LocationChanged);

            //PaintNow = BasePaint;

            //SizeNow = BaseResize;
        }

        void MovableNode_SizeChanged(object sender, EventArgs e)
        {

            NM.Location = HWidth(1);

        }

        protected Point HWidth(int NoRight) {

            return new Point(Width - (SideTopBuffer + (InterButtonBuffer + NM.Width) * NoRight) - NM.Width, SideTopBuffer);
        
        }

        protected override void OnMouseEnter(EventArgs e)
        {
            OrganiseLastSelectedControl(e);
        }

        public void OrganiseLastSelectedControl(EventArgs e)
        {

            //NodeContainer NC = (NodeContainer)Parent;

            NodeDocumentSurface NC = (NodeDocumentSurface)Parent;

            if (this != NC.ControlLast)
            {

                if (NC.ControlLast != null)
                    NC.ControlLast.HideChildren();

                if (!AreChildButtonsVisible)
                    ShowChildren();

                NC.ControlLast = this;

                base.OnMouseEnter(e);
            }

        }

        public void ShowChildren()
        {

            SetChildVisibleState(true);

        }

        public void HideChildren()
        {

            SetChildVisibleState(false);

        }

        public void SetChildVisibleState(bool state)
        {

            foreach (Control c in Controls)
            {
                if (c.GetType() != typeof(Label) && c.GetType() != typeof(DocumentContainer))
                    c.Visible = state;

                AreChildButtonsVisible = state;
            }
        }

        //protected override void OnPaint(PaintEventArgs e)
        //{

        //   PaintNow(e);
  
        //}

        //void BasePaint(PaintEventArgs e) {

        //    base.OnPaint(e);

        //    PaintNow = PaintAll;
        //}

        //protected void PaintAll(PaintEventArgs e) {

        //    base.OnPaint(e);

        //    Graphics g = e.Graphics;

        //    g.DrawPath(ForePen, Appearance);
        
        //}

        //protected override void OnResize(EventArgs eventargs)
        //{

        //    SizeNow(eventargs);

        //}

        //void BaseResize(EventArgs eventargs)
        //{

        //    base.OnResize(eventargs);

        //    SizeNow = ResizeAll;

        //}

        //protected virtual void ResizeAll(EventArgs eventargs) 
        //{
        //    base.OnResize(eventargs);

        //    Appearance.Reset();

        //    Appearance.AddLines(UpdateThePoints());
        
        //}

        //protected virtual Point[] UpdatePoints() { return new Point[0]; }

        //void MovableNode_LocationChanged(object sender, EventArgs e)
        //{
        //    if (i++ < 2)
        //    {
        //        LastPosX = Location.X;
        //        LastPosY = Location.Y;

        //    }
        //    else
        //    {

        //        LocationChanged -= new EventHandler(MovableNode_LocationChanged);

        //    }
        //}

        //void MovableNode_MouseDown(object sender, MouseEventArgs e)
        //{


        //    XDiff = Location.X - e.X;

        //    YDiff = Location.Y - e.Y;

        //    MouseMove += new MouseEventHandler(MovableNode_MouseMove);
        //    //Mouse Positions on the button must be accounted for

        //    //MousePosInButtonX = e.X;
        //    //MousePosInButtonY = e.Y;
        //}

        //void MovableNode_MouseUp(object sender, MouseEventArgs e)
        //{
        //    MouseMove -= new MouseEventHandler(MovableNode_MouseMove);
        //}

        //void MovableNode_MouseMove(object sender, MouseEventArgs e)
        //{


        //    Location = new Point(e.X + XDiff, e.Y + YDiff);

        //    System.Console.WriteLine("X: " + Location.X + "\n");
        //    System.Console.WriteLine("Y: " + Location.Y + "\n");
        //    System.Console.WriteLine("---------------------\n");

        //    //System.Console.WriteLine("X e.X - Location.X " + e.X + " - " + Location.X + ", Y e.Y - Location.Y, " + e.Y + " - " + Location.Y + "\n)");

        //    //System.Console.WriteLine("X " + (e.X - Location.X) + " Y " + (e.Y - Location.Y) + "\n)");
        //    //SetBounds(e.X + (e.X - Location.X), e.Y + (e.Y - Location.Y), Width, Height);

        //    //Button SB = (Button)sender;
        //    //The original position in the button must be noted and accounted for 

        //    //int PosXInPN = Location.X - e.X; // -MousePosInButtonX;
        //    //int PosYInPN = Location.Y - e.Y; // -MousePosInButtonY;

        //    //int NewLocX = (Location.X + (PosXInPN - LastPosX));
        //    //int NewLocY = (Location.Y + (PosYInPN - LastPosY));

        //    //SetBounds(NewLocX, NewLocY, Width, Height);

        //    //LastPosX = PosXInPN;
        //    //LastPosY = PosYInPN;

        //    //System.Console.WriteLine("\nX: " + NewLocX);
        //    //System.Console.WriteLine("Y: " + NewLocY);

        //    //Redraw affected lines
        //}

        ////Show the move button
        //void MovableNode_MouseEnter(object sender, EventArgs e)
        //{
        //    MouseDown += new MouseEventHandler(MovableNode_MouseDown);

        //    BackColor = Color.Green;
        //}

        //void MovableNode_MouseLeave(object sender, EventArgs e)
        //{
        //    MouseMove -= new MouseEventHandler(MovableNode_MouseMove);

        //    MouseDown -= new MouseEventHandler(MovableNode_MouseDown);

        //    BackColor = Color.Blue;
        //}

        //void MovableNode_Move(object sender, EventArgs e)
        //{
        //    //PrntClsObj.Refresh();
        //    ////Parent.Refresh();
        //}

        //protected void InitaliseLastPositions() {

        //    LastPosX = Location.X;
        //    LastPosY = Location.Y;

        //}

        public void SetSizeInParentBounds()
        {

            int XLocation = Location.X + Size.Width;
            int YLocation = Location.Y + Size.Height;

            bool H = IsOverBounds(Parent.Size.Width, XLocation);
            bool V = IsOverBounds(Parent.Size.Height, YLocation);

            if (H)
            {

                Size = new Size(ShrinkNode(Parent.Size.Width, XLocation, Size.Width), Size.Height);

                Refresh();
            }

            if (V)
            {

                Size = new Size(Size.Width, ShrinkNode(Parent.Size.Height, YLocation, Size.Height));

                Refresh();
            }

        }

        int ShrinkNode(int TotalLoc, int LocationOver, int ParentsSize)
        {
            int Offset = TotalLoc - LocationOver;

            return ParentsSize + Offset - 1;

        }

        bool IsOverBounds(int ParentParentWidth, int LocationAndSize)
        {

            return ParentParentWidth < LocationAndSize;

        }

    }
}
