using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class PreDefinedProcessNode : MoveableNode, ISaveMyself //, IHideToolBar
    {

        //Some lines of this have been copyed from the ResizeableNode class to make up for the lack of flexablity in terms of class inheritance.

        //NodeContainer Process = new NodeContainer();

        DocumentContainer Process = new DocumentContainer();

        //NodeToolBar NTB;

        DlNodeNR DN = new DlNodeNR();

        NodeResize NR = new NodeResize();

        NodeOutLine NO = new NodeOutLine();

        NodeDocResize NDR = new NodeDocResize();

        public PreDefinedProcessNode() {

            Initalise();

        }

        //public void LoadPreDefinedProcessNode(string NewWidth, string NewHeight, string LocationX, string LocationY)
        //{
        //    //Initalise();

        //    LoadNode(NewWidth, NewHeight, LocationX, LocationY);

        ////}

        public void LoadPreDefinedProcessNode(string NewWidth, string NewHeight, string LocationX, string LocationY, XElement ChildNodes)
        {
            //Initalise();

            LoadNode(NewWidth, NewHeight, LocationX, LocationY);

            Process.LoadDoc(ChildNodes);

        }


        void Initalise()
        {

            BackColor = Color.Transparent;

            //BackColor = Color.Red;

            SizeChanged += new EventHandler(PreDefinedProcessNode_SizeChanged);

            Controls.Add(DN);

            Controls.Add(NR);

            //Process.BackColor = Color.Sienna;

            Process.BackColor = SystemColors.Control;

            Controls.Add(Process);

            Controls.Add(NDR);

            Width++;

            MinimumSize = Size;
            //Size = new Size(500, 500);
            //Process.SetSize();

            Process.NewDocument();

            Process.Name = "SubNodes";

            //UpdateThePoints = UpdatePoints;

            //Appearance.AddLines(UpdatePoints());

            Name = "PreDefinedProcessNode";

        }

        void PreDefinedProcessNode_SizeChanged(object sender, EventArgs e)
        {
            int IntrXPadding = DN.Width * 2 + InterButtonBuffer * 3;

            DN.Location = new Point(Width - DN.Width - SideTopBuffer, SideTopBuffer);

            Process.Location = new Point(IntrXPadding, InterButtonBuffer);

            Process.Size = new Size(Width - IntrXPadding * 2, Height - InterButtonBuffer * 2);

            int HalfIn = InterButtonBuffer / 2;

            NR.Location = new Point(Width - NR.Width - HalfIn, Height - NR.Height - HalfIn);

            NDR.Location = new Point(NM.Location.X, NM.Location.Y + NM.Height + SideTopBuffer);
        }

        public XElement ProfileMe()
        {
            List<XAttribute> MyAttributes = ProfilePONode();

            XElement MeInXmlForm = new XElement(Name);

            foreach (XAttribute Attribute in MyAttributes)
                MeInXmlForm.Add(Attribute);

            MeInXmlForm.Add(Process.GetAllNodesXml());

            return MeInXmlForm;

        }

        Point[] UpdatePoints()
        {

            Point[] NewPoints = { new Point(InteriorPadding, InteriorPadding), new Point(Width - InteriorPadding, InteriorPadding), new Point(Width - InteriorPadding, Height - InteriorPadding), new Point(InteriorPadding, Height - InteriorPadding), new Point(InteriorPadding, InteriorPadding) };

            return NewPoints;
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            Graphics g = e.Graphics;

            NO.DrawOutLine(g, UpdatePoints());

            g.DrawLine(NO.DrawingPen, Process.Location.X - InteriorPadding, InteriorPadding, Process.Location.X - InteriorPadding, Height - InteriorPadding);

            g.DrawLine(NO.DrawingPen, Process.Location.X + Process.Width + InteriorPadding, InteriorPadding, Process.Location.X + Process.Width + InteriorPadding, Height - InteriorPadding);
        }

        //public void HideToolBar() { Document.Hide(); }

        //public void RevealToolBar() { Document.Show(); }

        public void ResizeDocument() {

            Process.ShowResizeDialouge();


    
        }
    }
}
