using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Xml.Linq;

namespace SimpleFlowDesigner
{
    class TerminalNode : NodeBase, ISaveMyself
    {

        static bool StartCreated;

        int XLeft;

        int XRight;

        //System.Drawing.Drawing2D.GraphicsPath Appearance = new System.Drawing.Drawing2D.GraphicsPath();

        Pen ForePen;

        public TerminalNode()
        {

            if (!StartCreated)
            {
                Text = "Start";

                StartCreated = true;

            }
            else
            {

                Text = "End";

            }

            NoBaseSizeChanged();

            //HAllignlbl();

            Resize += new EventHandler(TerminalNode_Resize);

            //BackColor = Color.Blue;

            //BackColor = Color.Transparent;

            //Height++; 

            Height = Height / 2;

            MinimumSize = Size;

            HAllignlbl();

            ForePen = new Pen(ForeColor, 3);

            //PaintNow = PaintIt;

            //UpdateLeftRightPoints();

            //Width++;

            //Refresh();

            Name = "TerminalNode";

        }

        public void CompletedTNodeCreation()
        {

            StartCreated = false;

        }

        void TerminalNode_Resize(object sender, EventArgs e)
        {
            UpdateLeftRightPoints();

            HAllignlbl();
        }

        public XElement ProfileMe()
        {

            List<XAttribute> MyAttributes = ProfilePONode();

            XElement MeInXmlForm = new XElement(Name);

            foreach (XAttribute Attribute in MyAttributes)
                MeInXmlForm.Add(Attribute);

            return MeInXmlForm;

        }

        void HAllignlbl() {

            lblPocText.Location = new Point(Width / 2 - lblPocText.Width / 2, Height / 2 - lblPocText.Height / 2);
        
        }

        void UpdateLeftRightPoints() {


            XLeft = Width / 4;

            XRight = Width - XLeft;
        
        }

        //Point[] UpdatePoints()
        //{

        //    Point[] NewPoints = { new Point(XLeft, InteriorPadding), new Point(XRight, InteriorPadding), new Point(XLeft, Height - InteriorPadding), new Point(XRight, Height - InteriorPadding) };

        //    return NewPoints;
        //}

        Point[] UpdateLeftCurvePoints()
        {

            Point[] NewPoints = { new Point(XLeft, InteriorPadding), new Point((InteriorPadding + XLeft) / 2, Height / 2), new Point(XLeft, Height - InteriorPadding) };

            return NewPoints;
        }

        Point[] UpdateRightCurvePoints()
        {

            Point[] NewPoints = { new Point(XRight, InteriorPadding), new Point(Width - InteriorPadding - XLeft / 2, Height / 2), new Point(XRight, Height - InteriorPadding) };

            return NewPoints;
        }

        //protected override void OnResize(EventArgs eventargs)
        //{
        //    base.OnResize(eventargs);

        //    UpdateLeftRightPoints();

        //    lblPocText.Location = new Point(Width / 2, Height / 2);

        //    //Appearance.AddLine(new Point(XLeft, InteriorPadding), new Point(XRight, InteriorPadding));

        //    //Appearance.AddCurve(UpdateRightCurvePoints());

        //    ////Appearance.AddArc(UpdateRightCurvePoints());

        //    //Appearance.AddLine(new Point(XLeft, Height - InteriorPadding), new Point(XRight, Height - InteriorPadding));

        //    //Appearance.AddCurve(UpdateLeftCurvePoints());

            

        //    //Appearance.AddArc(UpdateLeftCurvePoints(),);

        //}

        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);

            Graphics g = e.Graphics;

            //g.DrawString(Width + " ' " + Height, Font, Brush

            //g.DrawPath(ForePen, Appearance);

            g.DrawLine(ForePen, new Point(XLeft, InteriorPadding), new Point(XRight, InteriorPadding));

            g.DrawLine(ForePen, new Point(XLeft, Height - InteriorPadding), new Point(XRight, Height - InteriorPadding));

            //g.DrawArc(ForePen, 0, InteriorPadding, XLeft, Height - InteriorPadding * 2, 160, 94); 

            g.DrawCurve(ForePen, UpdateLeftCurvePoints(), 0, 2, 0.6F);

            g.DrawCurve(ForePen, UpdateRightCurvePoints(), 0, 2, 0.6F);

            //g.DrawCurve(ForePen, UpdateRightCurvePoints());
            
            //g.DrawCurve(ForePen, UpdateLeftCurvePoints());

        }

        //protected override void ResizeAll(EventArgs eventargs)
        //{
        //    base.OnResize(eventargs);

        //    Appearance.AddCurve(UpdateLeftCurvePoints());
        //    Appearance.AddCurve(UpdateRightCurvePoints());

        //}

        //void PaintIt(PaintEventArgs e)
        //{

        //    base.OnPaint(e);

            
        //}

    }
}
