using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public partial class LineEditor : Form
    {
        Connector Nde;

        //ArrowStates NewArrowState = ArrowStates.None;

        public LineEditor()
        {
            InitializeComponent();
            
            Visible = false;

            TopMost = true;

            FormClosing += new FormClosingEventHandler(LineEditorForm_FormClosing);

            BtnUpdate.Click += new EventHandler(BtnUpdate_Click);

            rdbRB.Click += new EventHandler(rdbRB_Click);

            rdbNone.Click += new EventHandler(rdbNone_Click);

            rdbLT.Click += new EventHandler(rdbLT_Click);

            chbShowLabel.Click += new EventHandler(chbShowLabel_Click); 

        }

        void chbShowLabel_Click(object sender, EventArgs e)
        {
            Nde.ChangeLabelVisibleState();
        }

        //protected override void OnClosing(CancelEventArgs e)
        //{
           
        //    if (e.CloseReason == CloseReason.UserClosing)
        //    {
        //        e.Cancel = true;

        //        Visible = false;

        //    } else
        //        base.OnClosing(e);
        //}

        void LineEditorForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.UserClosing)
            {
                e.Cancel = true;

                Visible = false;

                UnHighLightNode();

                Nde = null;

            }
        }

        private void BtnUpdate_Click(object sender, EventArgs e)
        {

            try
            {

                Nde.Text = tbxText.Text;

                //Nde.ArrowState = NewArrowState;

            }
            catch (Exception ex) {

                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
            
            }

        }

        public Connector EditingNode {

            get {return Nde; }

            set {

                chbShowLabel.CheckedChanged -= new System.EventHandler(chbShowLabel_CheckedChanged);

                UnHighLightNode();

                Nde = value;

                Nde.Highlight();

                tbxText.Text = Nde.Text;

                //if(!BtnUpdate.Enabled)
                //    ReverseUpdatableState();


                if (Nde.LabelVisibleState)
                {

                    chbShowLabel.Checked = true;

                    if(!tbxText.Enabled && !BtnUpdate.Enabled)
                        SwitchLabelEditorEnabledState();

                } else
                {

                    chbShowLabel.Checked = false;

                    if (tbxText.Enabled && BtnUpdate.Enabled)
                        SwitchLabelEditorEnabledState();
                }

                //if(!chbShowLabel.Checked)
                //     SwitchLabelEditorEnabledState();

                if (!Visible)
                    Visible = true;

                GetAndSetArrowType();

                chbShowLabel.CheckedChanged += new System.EventHandler(chbShowLabel_CheckedChanged);

            }
        
        }

        void SwitchLabelEditorEnabledState()
        {
            tbxText.Enabled = !tbxText.Enabled;
            BtnUpdate.Enabled = !BtnUpdate.Enabled;

        }

        private void UnHighLightNode() {

            if (Nde != null)
                Nde.UnHighlight();
        
        }

        private void GetAndSetArrowType() { 
        
            switch (Nde.ArrowState) {
            
                case ArrowStates.BottomOrRight:

                    //rdbRB.Click -= new System.EventHandler(this.rdbRB_Click);

                    rdbRB.Checked = true;

                    //rdbRB.Click += new System.EventHandler(this.rdbRB_Click);
                    
                    break;

                case ArrowStates.None:

                    //rdbNone.Click -= new System.EventHandler(this.rdbNone_Click);

                    rdbNone.Checked = true;

                    //rdbNone.Click += new System.EventHandler(this.rdbNone_Click);

                    break;

                case ArrowStates.TopOrLeft:

                    //rdbLT.Click -= new System.EventHandler(this.rdbLT_Click);

                    rdbLT.Checked = true;

                    //rdbLT.Click += new System.EventHandler(this.rdbLT_Click);

                    break;
   
            }

        }

        //public void ReverseUpdatableState() {

        //    BtnUpdate.Enabled = !BtnUpdate.Enabled;  

        //}

        private void rdbLT_Click(object sender, EventArgs e)
        {
                
            Nde.ArrowState = ArrowStates.TopOrLeft;
        }

        private void rdbNone_Click(object sender, EventArgs e)
        {
            Nde.ArrowState = ArrowStates.None;
        }

        private void rdbRB_Click(object sender, EventArgs e)
        {
            Nde.ArrowState = ArrowStates.BottomOrRight;
        }

        private void chbShowLabel_CheckedChanged(object sender, EventArgs e)
        {
            SwitchLabelEditorEnabledState();
        }


        //public override void Dispose()
        //{


        //}
    }
}