using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SimpleFlowDesigner
{
    public partial class NodeTextEditorForm : Form
    {
       NodeBase Nde;

        public NodeTextEditorForm()
        {
            InitializeComponent();
            
            Visible = false;

            TopMost = true;

            FormClosing += new FormClosingEventHandler(NodeTextEditorForm_FormClosing);

        }

        void NodeTextEditorForm_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (e.CloseReason == CloseReason.UserClosing)
            {
                e.Cancel = true;

                Visible = false;
                
            }
        }

        private void BtnUpdate_Click(object sender, EventArgs e)
        {

            try
            {

                Nde.Text = tbxText.Text;

            }
            catch (Exception ex) {

                MessageBox.Show(ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation); 
            
            }

        }

        public NodeBase EditingNode {

            get {return Nde; }

            set { 
           
                Nde = value;

                tbxText.Text = Nde.Text;

                if(!BtnUpdate.Enabled)
                    ReverseUpdatableState();

                if (!Visible)
                    Visible = true;
            }
        
        }

        public void ReverseUpdatableState() {

            BtnUpdate.Enabled = !BtnUpdate.Enabled;  

        }
    }
}