﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace SimpleFlowDesigner
{
    class NodeToolBar : ToolStrip //, IHideToolBar
    {

        System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(SimpleFlowDesignerMain));

        ToolStripLabel toolStripLabel = new ToolStripLabel();
        ToolStripSeparator toolStripSeparator = new ToolStripSeparator();
        ToolStripSeparator toolStripSeparator0 = new ToolStripSeparator();


        NodeToolButton DecisionNodeButton = new NodeToolButton();
        NodeToolButton InputOutPutNodeButton = new NodeToolButton();
        NodeToolButton PreDefinedProcessNodeButton = new NodeToolButton();
        NodeToolButton ProcessNodeButton = new NodeToolButton();
        NodeToolButton ConnectorButton = new NodeToolButton();

        NodeDocument AttachedDocument;

        public NodeToolBar(NodeDocument AttachedDocument) {

            this.AttachedDocument = AttachedDocument;

            SuspendLayout();

            Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
            toolStripLabel,
            toolStripSeparator,
            ProcessNodeButton,
            InputOutPutNodeButton,
            DecisionNodeButton,
            PreDefinedProcessNodeButton,
            ConnectorButton,
            toolStripSeparator0});

            toolStripLabel.Text = "Nodes";

            ProcessNodeButton.Text = "Process Node";
            InputOutPutNodeButton.Text = "InputOutPut Node";
            DecisionNodeButton.Text = "Decision Node";
            PreDefinedProcessNodeButton.Text = "PreDefined Process Node";
            ConnectorButton.Text = "Connector";

            //ProcessNodeButton.Image = Bitmap.FromFile("C:\\Old Projects\\SimpleFlowDesigner\\Resources\\PROCIconSmall.png");
            //InputOutPutNodeButton.Image = Bitmap.FromFile("C:\\Old Projects\\SimpleFlowDesigner\\Resources\\INOUTIconSmall.png");
            //DecisionNodeButton.Image = Bitmap.FromFile("C:\\Old Projects\\SimpleFlowDesigner\\Resources\\DECIIconSmall.png");
            //PreDefinedProcessNodeButton.Image = Bitmap.FromFile("C:\\Old Projects\\SimpleFlowDesigner\\Resources\\PREDIconSmall.png");
            //ConnectorButton.Image = Bitmap.FromFile("C:\\Old Projects\\SimpleFlowDesigner\\Resources\\CONIIconSmall.png");

            //ProcessNodeButton.Image = ((System.Drawing.Image)(resources.GetObject("PROCIconSmall")));
            //InputOutPutNodeButton.Image = ((System.Drawing.Image)(resources.GetObject("INOUTIconSmall")));
            //DecisionNodeButton.Image = ((System.Drawing.Image)(resources.GetObject("DECIIconSmall")));
            //PreDefinedProcessNodeButton.Image = ((System.Drawing.Image)(resources.GetObject("PREDIconSmall")));
            //ConnectorButton.Image = ((System.Drawing.Image)(resources.GetObject("CONIIconSmall")));

            ProcessNodeButton.Image = Bitmap.FromFile("Resources\\PROCIconSmall.png");
            InputOutPutNodeButton.Image = Bitmap.FromFile("Resources\\INOUTIconSmall.png");
            DecisionNodeButton.Image = Bitmap.FromFile("Resources\\DECIIconSmall.png");
            PreDefinedProcessNodeButton.Image = Bitmap.FromFile("Resources\\PREDIconSmall.png");
            ConnectorButton.Image = Bitmap.FromFile("Resources\\CONIIconSmall.png");


            //I would do this in the constructor but the desired effect is not produced.

            //ProcessNodeButton.BackColor = SystemColors.Control;
            //InputOutPutNodeButton.BackColor = SystemColors.Control;
            //DecisionNodeButton.BackColor = SystemColors.Control;
            //PreDefinedProcessNodeButton.BackColor = SystemColors.Control;
            //ConnectorButton.BackColor = SystemColors.Control;

            //Color FullyTransparent = Color.FromArgb(0, 0, 0, 0);
            //Color.Transparent;
            ProcessNodeButton.BackColor = Color.Transparent;
            InputOutPutNodeButton.BackColor = Color.Transparent;
            DecisionNodeButton.BackColor = Color.Transparent;
            PreDefinedProcessNodeButton.BackColor = Color.Transparent;
            ConnectorButton.BackColor = Color.Transparent;

            ProcessNodeButton.Click += new EventHandler(ProcessNodeButton_Click);
            InputOutPutNodeButton.Click += new EventHandler(InputOutPutNodeButton_Click);
            DecisionNodeButton.Click += new EventHandler(DecisionNodeButton_Click);
            PreDefinedProcessNodeButton.Click += new EventHandler(PreDefinedProcessNodeButton_Click);
            ConnectorButton.Click += new EventHandler(ConnectorButton_Click);

            ResumeLayout();

        }

        void ConnectorButton_Click(object sender, EventArgs e)
        {
            AttachedDocument.AddConnector();
        }

        void PreDefinedProcessNodeButton_Click(object sender, EventArgs e)
        {
            AttachedDocument.AddPreDefinedProcessNode();
        }

        void DecisionNodeButton_Click(object sender, EventArgs e)
        {
            AttachedDocument.AddDecisionNode();
        }

        void InputOutPutNodeButton_Click(object sender, EventArgs e)
        {
            AttachedDocument.AddInputOutPutNode();
        }

        void ProcessNodeButton_Click(object sender, EventArgs e)
        {
            AttachedDocument.AddProcessNode();
        }

        //public void HideToolBar() { AttachedDocument.Hide(); }

        //public void RevealToolBar() { AttachedDocument.Show(); }

    }
}
